<?php
	//please replace with your settings...
	$i18n_folder = "Custom/Resources";
	$uiAutomationFolder = "Test/UIAutomationTests/lib";
	
	if(substr($i18n_folder, -1) != "/"){
		$i18n_folder.="/";
	}
	$langs = array();
	$ihandle = opendir($i18n_folder);
	if ($ihandle) {
	 	while (false !== ($file = readdir($ihandle))) {
        	if(substr($file, -6) == ".lproj" 
        	&& file_exists ( $i18n_folder."/".$file."/Localizable.strings" )){
				$langs[] = $file;
        	}
    	}
    	closedir($ihandle);
	}
	if(count($langs) > 0){
		$l = 0;
		$ohandle =  fopen($uiAutomationFolder."/Localizables.js", "w");
		if($ohandle){
			fwrite($ohandle, "if(typeof(UIA) == \"undefined\"){var UIA = {};}\n");	
			fwrite($ohandle, "if(typeof(application) == \"undefined\"){var application = UIATarget.localTarget().frontMostApp();}\n");	
			fwrite($ohandle, "UIA.Localizables = {\n");					
			foreach($langs as $lang){
				$l++;
				$i = 0;	
				fwrite($ohandle, "\t\"".substr($lang, 0, -6)."\":{\n");
				$localizable =  file ($i18n_folder."/".$lang."/Localizable.strings");
				foreach($localizable as $line){
					$i++;
					if(substr($line, 0, 1) == "\""){
						$larr = explode("=", trim($line));
						fwrite($ohandle, "\t\t".$larr[0].":".substr($larr[1],0,-1));
						if($i < count($localizable)){
							fwrite($ohandle,",\n");
						}else{
 							fwrite($ohandle, "\n");
 						}	
					}
				}
				fwrite($ohandle, "\t}");
				
 				if($l < count($langs)){
 					fwrite($ohandle, ",\n");	
 				}else{
 					fwrite($ohandle, "\n");
 				}
 				
			}
			fwrite($ohandle, "}\n");			
			fwrite($ohandle, "\tUIA.getCurrentLang = function(){\n");
			fwrite($ohandle, "\t\tif(application.preferencesValueForKey(\"AppleLanguages\")[0]  == \"en\")\n");
			fwrite($ohandle, "\t\t\treturn \"English\";\n");
			fwrite($ohandle, "\t\telse\n");
			fwrite($ohandle, "\t\t\treturn application.preferencesValueForKey(\"AppleLanguages\")[0];\n");
			fwrite($ohandle, "\t}\n");				
			fwrite($ohandle, "\tUIA.getCurrentLocalizables = function(){\n");
			fwrite($ohandle, "\t\treturn UIA.Localizables[UIA.getCurrentLang()];\n");				
			fwrite($ohandle, "\t}\n");				
			
			fwrite($ohandle, "\n");
			fwrite($ohandle, "var Localizable = UIA.getCurrentLocalizables();\n");
			fwrite($ohandle, "\n");
			
			fflush($ohandle);
			fclose($ohandle);	
		}	
	}
?>